Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB Java Edition version 3.3.82
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sleepycat.bind.serial
Interface ClassCatalog

All Known Implementing Classes:
  StoredClassCatalog

    public interface ClassCatalog

A catalog of class description information for use during object serialization.

A catalog is used to store class descriptions separately from serialized objects, to avoid redundantly stored information with each object. When serialized objects are stored in a database, a `StoredClassCatalog` should be used.

This information is used for serialization of class descriptors or java.io.ObjectStreamClass objects, each of which represents a unique class format. For each unique format, a unique class ID is assigned by the catalog. The class ID can then be used in the serialization stream in place of the full class information. When used with `SerialInput` and `SerialOutput` or any of the serial bindings, the use of the catalog is transparent to the application.

Author:
  Mark Hayes
See Also:
  Class Evolution

Method Summary
`void` | `close()` Close a catalog database and release any cached resources.
`ObjectStreamClass` | `getClassFormat(byte[] classID)` Return the ObjectStreamClass for the given class ID.
`byte[]` | `getClassID(ObjectStreamClass classDesc)` Return the class ID for the current version of the given class description.

Method Detail

### close

    void close()
               throws DatabaseException

  Close a catalog database and release any cached resources.

  Throws:
    `DatabaseException`

### getClassID

    byte[] getClassID(ObjectStreamClass classDesc)
                      throws DatabaseException,
                             ClassNotFoundException

  Return the class ID for the current version of the given class description. This is used for storing in serialization streams in place of a full class descriptor, since it is much more compact. To get back the ObjectStreamClass for a class ID, call `getClassFormat(byte[])`. This function causes a new class ID to be assigned if the class description has changed.

  Parameters:
    `classDesc` - The class description for which to return the class ID.
  Returns:
    The class ID for the current version of the class.
  Throws:
    `DatabaseException`
    `ClassNotFoundException`

### getClassFormat

    ObjectStreamClass getClassFormat(byte[] classID)
                                     throws DatabaseException,
                                            ClassNotFoundException

  Return the ObjectStreamClass for the given class ID. This may or may not be the current class format, depending on whether the class has changed since the class ID was generated.

  Parameters:
    `classID` - The class ID for which to return the class format.
  Returns:
    The class format for the given class ID, which may or may not represent the current version of the class.
  Throws:
    `DatabaseException`
    `ClassNotFoundException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB Java Edition version 3.3.82
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004,2008 Oracle. All rights reserved.